function itemsElement() {
  const items = [...document.querySelectorAll(".link")];

  return items.map((item, index) => ({
    element: item,
    image: item.querySelector("img") || null,
    index: index,
  }));
}

itemsElement();

function imagePromises() {
  let promises = [];

  let items = itemsElement();

  const myLoader = new THREE.TextureLoader();

  items.forEach((item, index) => {
    promises.push(
      loadTexture(myLoader, item.image ? item.image.src : null, index)
    );
  });

  return new Promise((resolve, reject) => {
    // resolve
    Promise.all(promises).then((promises) => {
      // all textures laoded
      promises.forEach((promise, index) => {
        //assign texture to item
        items[index].texture = promise.texture;
      });

      resolve();
    });
  });
}

function loadTexture(loader, url, index) {
  return new Promise((resolve, reject) => {
    if (!url) {
      resolve({ texture: null, index });
      return;
    } else {
      // load a resource
      loader.load(
        // resource url
        url,

        // onLoad callback
        (texture) => {
          resolve({ texture, index });
        },

        // onProgress callback
        undefined,

        // onError callback
        (error) => {
          console.error("An error happened", error);
          reject(error);
        }
      );
    }
  });
}

imagePromises();
loadTexture();
